/*
 * This file was generated by qdbusxml2cpp version 0.7
 * Command line was: qdbusxml2cpp -l Oscl::Qt::DBus::BlueZ::Mesh::Node1::Server -i ushortarray.h -i server.h -a adaptor dbus.xml
 *
 * qdbusxml2cpp is Copyright (C) 2015 The Qt Company Ltd.
 *
 * This is an auto-generated file.
 * This file may have been hand-edited. Look for HAND-EDIT comments
 * before re-generating it.
 */

#ifndef ADAPTOR_H_1600719962
#define ADAPTOR_H_1600719962

#include <QtCore/QObject>
#include <QtDBus/QtDBus>
#include "ushortarray.h"
#include "server.h"
class QByteArray;
template<class T> class QList;
template<class Key, class Value> class QMap;
class QString;
class QStringList;
class QVariant;

/*
 * Adaptor class for interface org.bluez.mesh.Node1
 */
class Node1Adaptor: public QDBusAbstractAdaptor
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.bluez.mesh.Node1");
    Q_CLASSINFO("D-Bus Introspection", ""
"  <interface name=\"org.bluez.mesh.Node1\">\n"
"    <method name=\"Send\">\n"
"      <arg direction=\"in\" type=\"o\" name=\"element_path\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"destination\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"key_index\"/>\n"
"      <arg direction=\"in\" type=\"a{sv}\" name=\"options\"/>\n"
"      <arg direction=\"in\" type=\"ay\" name=\"data\"/>\n"
"      <annotation value=\"QVariantMap\" name=\"org.qtproject.QtDBus.QtTypeName.In3\"/>\n"
"      <!--\n"
"      <annotation name=\"org.qtproject.QtDBus.QtTypeName.In3\" value=\"Node1SendOptions\"/>\n"
"	-->\n"
"    </method>\n"
"    <method name=\"DevKeySend\">\n"
"      <arg direction=\"in\" type=\"o\" name=\"element_path\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"destination\"/>\n"
"      <arg direction=\"in\" type=\"b\" name=\"remote\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"net_index\"/>\n"
"      <arg direction=\"in\" type=\"a{sv}\" name=\"options\"/>\n"
"      <arg direction=\"in\" type=\"ay\" name=\"data\"/>\n"
"      <annotation value=\"QVariantMap\" name=\"org.qtproject.QtDBus.QtTypeName.In4\"/>\n"
"      <!--\n"
"      <annotation name=\"org.qtproject.QtDBus.QtTypeName.In4\" value=\"Node1DevKeySendOptions\"/>\n"
"	-->\n"
"    </method>\n"
"    <method name=\"AddNetKey\">\n"
"      <arg direction=\"in\" type=\"o\" name=\"element_path\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"destination\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"subnet_index\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"net_index\"/>\n"
"      <arg direction=\"in\" type=\"b\" name=\"update\"/>\n"
"    </method>\n"
"    <method name=\"AddAppKey\">\n"
"      <arg direction=\"in\" type=\"o\" name=\"element_path\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"destination\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"app_index\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"net_index\"/>\n"
"      <arg direction=\"in\" type=\"b\" name=\"update\"/>\n"
"    </method>\n"
"    <method name=\"Publish\">\n"
"      <arg direction=\"in\" type=\"o\" name=\"element_path\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"model\"/>\n"
"      <arg direction=\"in\" type=\"a{sv}\" name=\"options\"/>\n"
"      <arg direction=\"in\" type=\"ay\" name=\"data\"/>\n"
"      <annotation value=\"QVariantMap\" name=\"org.qtproject.QtDBus.QtTypeName.In2\"/>\n"
"      <!--\n"
"      <annotation name=\"org.qtproject.QtDBus.QtTypeName.In2\" value=\"Node1PublishOptions\"/>\n"
"	-->\n"
"    </method>\n"
"    <property access=\"read\" type=\"a{sv}\" name=\"Features\">\n"
"      <annotation value=\"QVariantMap\" name=\"org.qtproject.QtDBus.QtTypeName\"/>\n"
"      <!--\n"
"		<annotation name=\"org.qtproject.QtDBus.QtTypeName\" value=\"Node1Features\"/>\n"
"	-->\n"
"    </property>\n"
"    <property access=\"read\" type=\"b\" name=\"Beacon\"/>\n"
"    <property access=\"read\" type=\"b\" name=\"IvUpdate\"/>\n"
"    <property access=\"read\" type=\"u\" name=\"IvIndex\"/>\n"
"    <property access=\"read\" type=\"u\" name=\"SecondsSinceLastHeard\"/>\n"
"    <property access=\"read\" type=\"aq\" name=\"Addresses\">\n"
"      <annotation value=\"Oscl::Qt::DBus::BlueZ::Mesh::Node1::UshortArray\" name=\"org.qtproject.QtDBus.QtTypeName\"/>\n"
"      <!--\n"
"		<annotation name=\"org.qtproject.QtDBus.QtTypeName\" value=\"QList<ushort>\"/>\n"
"	-->\n"
"    </property>\n"
"    <property access=\"read\" type=\"u\" name=\"SequenceNumber\"/>\n"
"  </interface>\n"
        "");

public:
    Node1Adaptor(Oscl::Qt::DBus::BlueZ::Mesh::Node1::Server *parent);
    virtual ~Node1Adaptor();

    inline Oscl::Qt::DBus::BlueZ::Mesh::Node1::Server *parent() const
    { return static_cast<Oscl::Qt::DBus::BlueZ::Mesh::Node1::Server *>(QObject::parent()); }

public: // PROPERTIES
    Q_PROPERTY(Oscl::Qt::DBus::BlueZ::Mesh::Node1::UshortArray Addresses READ addresses)
    Oscl::Qt::DBus::BlueZ::Mesh::Node1::UshortArray addresses() const;

    Q_PROPERTY(bool Beacon READ beacon)
    bool beacon() const;

    Q_PROPERTY(QVariantMap Features READ features)
    QVariantMap features() const;

    Q_PROPERTY(uint IvIndex READ ivIndex)
    uint ivIndex() const;

    Q_PROPERTY(bool IvUpdate READ ivUpdate)
    bool ivUpdate() const;

    Q_PROPERTY(uint SecondsSinceLastHeard READ secondsSinceLastHeard)
    uint secondsSinceLastHeard() const;

    Q_PROPERTY(uint SequenceNumber READ sequenceNumber)
    uint sequenceNumber() const;

public Q_SLOTS: // METHODS
    void AddAppKey(const QDBusObjectPath &element_path, ushort destination, ushort app_index, ushort net_index, bool update);
    void AddNetKey(const QDBusObjectPath &element_path, ushort destination, ushort subnet_index, ushort net_index, bool update);
    void DevKeySend(const QDBusObjectPath &element_path, ushort destination, bool remote, ushort net_index, const QVariantMap &options, const QByteArray &data);
    void Publish(const QDBusObjectPath &element_path, ushort model, const QVariantMap &options, const QByteArray &data);
    void Send(const QDBusObjectPath &element_path, ushort destination, ushort key_index, const QVariantMap &options, const QByteArray &data);
Q_SIGNALS: // SIGNALS
};

#endif
